#!/bin/bash

# Prints out FW/SW/HW versions of various devices and components

function printWithPad() {
    printf "%-16s %s\n" "$1" "$2"
}

# Software
KERNEL_VERSION=`uname -r`
UBOOT_VERSION=`strings /dev/mmcblk1boot0 | grep -m 1 "U-Boot 20" | sed -n -e 's/^.*U-Boot //p'`

# Hardware / firmware
CPU_NAME=`cat /proc/cpuinfo | grep Hardware | sed -n -e 's/^.*: //p'`
CPU_SERIAL=`cat /proc/cpuinfo | grep Serial | sed -n -e 's/^.*: //p'`

TOUCH_NAME=`cat /sys/bus/i2c/devices/2-0024/name`
TOUCH_DRV_VER=`cat /sys/bus/i2c/devices/2-0024/drv_ver | sed -n -e 's/^.*Version: //p'`
TOUCH_INFO=`cat /sys/bus/i2c/devices/2-0024/ic_ver`

MMC_NAME=`cat /sys/bus/mmc/devices/mmc1\:0001/name`
MMC_SERIAL=`cat /sys/bus/mmc/devices/mmc1\:0001/serial`

PMIC_NAME=`cat /sys/bus/i2c/devices/0-0048/name`
PFUZE_NAME=`cat /sys/bus/i2c/devices/0-0008/name`
FUEL_GAUGE_NAME=`cat /sys/bus/i2c/devices/0-0055/name`
WIFI_NAME="TBD"

# Print
printWithPad "Kernel:" "${KERNEL_VERSION}"
printWithPad "U-Boot:" "${UBOOT_VERSION}"
echo
printWithPad "CPU NAME:" "${CPU_NAME}"
printWithPad "CPU SERIAL:" "${CPU_SERIAL}"
echo
printWithPad "TOUCH_NAME: " "${TOUCH_NAME}"
printWithPad "TOUCH_DRIVER:" "${TOUCH_DRV_VER}"
echo "TOUCH INFO:"
echo "${TOUCH_INFO}"
echo
printWithPad "MMC NAME:" "${MMC_NAME}"
printWithPad "MMC SERIAL:" "${MMC_SERIAL}"
echo
printWithPad "PMIC NAME:" "${PMIC_NAME}"
printWithPad "PFUZE NAME:" "${PFUZE_NAME}"
printWithPad "FUEL GAUGE:" "${FUEL_GAUGE_NAME}"
printWithPad "WIFI NAME:" "${WIFI_NAME}"
